const RATIO = 0.75; // Image width:height ratio

var FdPrefs = {
  prefs: Components.classes["@mozilla.org/preferences-service;1"]
         .getService(Components.interfaces.nsIPrefService)
         .getBranch("extensions.fastdial."),

  getPageInfo: function(id) {
    var pageInfo = { id: id, url: "", title: "", refreshOnVisit: false, refresh: 0 };
    try {
      pageInfo = eval(this.prefs.getCharPref(id));
      pageInfo.title = decodeURIComponent(pageInfo.title);
      pageInfo.refresh = parseInt(pageInfo.refresh) > 0 ? pageInfo.refresh : 0;
      pageInfo.id = id;
    } catch(e) {}
    return pageInfo;
  },

  savePageInfo: function(pageInfo) {
    this.prefs.setCharPref(pageInfo.id, "({ url: '" + pageInfo.url + "', " +
                                           "title: '" + encodeURIComponent(pageInfo.title) + "', " +
                                           "refreshOnVisit: " + pageInfo.refreshOnVisit + ", " +
                                           "refresh: " + pageInfo.refresh + "})");
  },

  clearPageInfo: function(id) {
    try {
      this.prefs.deleteBranch(id);
    } catch(e) {}
  },

  saveWindowSize: function() {
    var wnd = gBrowser.selectedBrowser.contentWindow;
    this.prefs.setCharPref("windowSize", "({ width: " + wnd.innerWidth + ", " +
                                            "height: " + wnd.innerHeight + " })");
  },

  getWindowSize: function() {
    try {
      return eval(this.prefs.getCharPref("windowSize"));
    } catch(e) {
      return null;
    }
  },

  getBoolPref: function(name) {
    try {
      return this.prefs.getBoolPref(name);
    } catch(e) {
      return false;
    }
  },

  setBoolPref: function(name, value) {
    this.prefs.setBoolPref(name, value);
  },

  getIntPref: function(name) {
    try {
      return this.prefs.getIntPref(name);
    } catch(e) {
      return 0;
    }
  },

  setIntPref: function(name, value) {
    this.prefs.setIntPref(name, value);
  }
}
